<?php
/*
* Plugin Name: Crew Manager
* File admin.php
* File Version 1.1.0 Beta
* Author: Bill Kneller
* Author URI: http://crew-mgr.com
* This is the admin screen to set plugin options.  
* It is accessible with Skipper Admin privledges
* 
* 6/18/2018 added settings for crew weight reports
* 6/6/2018 added skipper email capability
* 5/24/2018 added Retired group and revised instructions
* 5/21/2018 added setting to allow Crew to set Email Optout
* 5/15/2018 modified email sending and email list management
*  to remove requirement for ELP plugin 
* 5/7/2018 added radio buttons to turn on/off crew emails
* 4/18/2018 changed time zone correction method with dropdown
**/
$crew_manager_options['time_zone'] = "America/New_York";  // force initial settings if not yet in table
$crew_manager_options['lead_time'] = 36;    // force initial settings if not yet in table
$crew_manager_options['wp_admin_hide'] = 1;    // force initial settings (hide wp admin from roster) if not yet in table
$crew_manager_options['crew_hide'] = 1;    // force initial settings (hide not available) if not yet in table
$crew_manager_options['availability_hide'] = 1;    // force initial settings (hide not available) if not yet in table
$crew_manager_options['elp_cron_trigger'] = 1;    // force initial settings for Crew Manager to trigger CRON if not yet in table
$crew_manager_options['skipper_admin'] = "";     // force initial settings if not yet in table
$crew_manager_options['skipper'] = "";     // force initial settings if not yet in table
$crew_manager_options['stop_crew_email'] = 1;    // force initial settings (stop sending crew emails) if not yet in table
$crew_manager_options['crew_email_allow_optout'] = 1;    // force initial settings (permit crew to optout of emails) if not yet in table

$crew_manager_options['stop_elp_notifications'] = 1; 
if (get_option('crew_manager_settings'))$crew_manager_options = get_option('crew_manager_settings'); // forces initial variables until saved in WP
if (!$crew_manager_options['time_zone'])$crew_manager_options['time_zone'] = "America/New_York";  // force initial settings if not yet in table
if (!$crew_manager_options['lead_time'])$crew_manager_options['lead_time'] = 36;    // force initial settings if not yet in table
if (!$crew_manager_options['crew_hide'])$crew_manager_options['crew_hide'] = 1;    // force initial settings (hide not available) if not yet in table
if (!$crew_manager_options['availability_hide'])$crew_manager_options['availability_hide'] = 1;    // force initial settings (hide not available) if not yet in table
 if (!$crew_manager_options['elp_cron_trigger'])$crew_manager_options['elp_cron_trigger'] = 1;    // force initial settings for Crew Manager to trigger CRON if not yet in table
 if (!$crew_manager_options['stop_elp_notifications'])$crew_manager_options['stop_elp_notifications'] = 1;    // force initial settings for Crew Manager to trigger ELP notification emails if not yet in table
 if (!$crew_manager_options['stop_crew_email'])$crew_manager_options['stop_crew_email'] = 1;    // force initial settings for Crew Manager to disable CREW emails if not yet in table
 if (!$crew_manager_options['crew_email_allow_optout'])$crew_manager_options['crew_email_allow_optout'] = 1;    // force initial settings (permit crew to optout of emails) if not yet in table
if (!$crew_manager_options['weight_limit'])$crew_manager_options['weight_limit'] = 0;    // force initial settings to 0 (no limit) if not yet in table
if (!$crew_manager_options['include_helm'])$crew_manager_options['include_helm'] = 2;    // force initial settings to 2 (include) if not yet in table


add_action('admin_menu', 'crew_manager_plugin_setup_menu'); 

function crew_manager_plugin_setup_menu(){
        add_menu_page( 'Crew Manager Plugin', 'Crew Manager', 'edit_posts', 'crew-manager', 'crew_manager_init', 'dashicons-universal-access-alt', 65 );
$parent_slug = 'crew-manager';
$page_title = 'Position Editor';
$menu_title = 'Edit Position Titles'; 
$capability = 'edit_posts'; 
$menu_slug = 'edit-positions';
$function = 'crew_manager_edit_positions_page';
    add_submenu_page($parent_slug, 'Modify Settings', 'Modify Settings', $capability, $parent_slug, '' );
    add_submenu_page($parent_slug, $page_title, $menu_title, $capability, $menu_slug, $function );
    add_submenu_page($parent_slug, 'Manage Email Lists', 'Manage Email Lists', $capability, 'manage-email', 'crew_manager_email_list_page' );
    add_submenu_page($parent_slug, 'Skipper Send Email', 'Skipper Send Email', $capability, 'send-email', 'crew_manager_skipper_email_page' );
}

/**
* Everything in this function is displayed on the crew manager admin screen
* All other functions below this are called to be executed in this 
**/
function crew_manager_init(){
        echo "<h1>Crew Manager Admin Setup</h1>";
global $crew_manager_options;

$skipper_admin = get_registered_users_dropdown($crew_manager_options['skipper_admin']);
$skipper_name = get_registered_users_dropdown($crew_manager_options['skipper']);

?>
	<table class="form-table">
    <form class="form-table" method="post" action="options.php">
        <?php settings_fields('crew_manager_group') ?>
		<tr>
			<td width="20%"><label for="crew_manager_settings[time_zone]">
                <?= __('<b>Correct Time for <br>Local Time Zone</b>', 'textdomain') ?>
                </label>
			</td>
			<td width="30%"  align="left">
				<? echo load_timezone_dropdown($crew_manager_options['time_zone']); ?><br />

				<span class="description">Select the local time zone</span>
			</td>
			<td width="45%">
			Corrects time difference between the server and local time displayed for events so no other adjustments are needed when making entries.
			</td>
			<td width="5%">
			</td>
		</tr>


		<tr>
			<td><label for="crew_manager_settings[stop_crew_email]">
                <?= __('<b>Crew Email <br>Turn On or Off</b>', 'textdomain') ?>
                </label>
			<td>
		 <b>Send Crew Email:&nbsp;&nbsp;</b>
 <input type="radio" name="crew_manager_settings[stop_crew_email]" VALUE="1" <?php checked(1, $crew_manager_options['stop_crew_email'], true); ?>>On
		 <input type="radio" name="crew_manager_settings[stop_crew_email]" VALUE="2" <?php checked(2, $crew_manager_options['stop_crew_email'], true); ?>>Off<br />
				<span class="description">Select to turn On / Off automatic Crew emails using radio buttons.</span>
			</td>
			<td>
			Using <em>On</em> or <em>Off</em> options, automatic Crew emails for event notification, new posts and results may be set.  This may be turned off while making event, race results and post updates so the crew does not get emails, then turned on after updates are complete.
			</td>
		</tr>

		<tr>
			<td><label for="crew_manager_settings[crew_email_allow_optout]">
                <?= __('<b>Crew Email Optout<br>Allow Crew to Set</b>', 'textdomain') ?>
                </label>
			<td>
		 <b>Crew Set Email Optout:&nbsp;&nbsp;</b>
 <input type="radio" name="crew_manager_settings[crew_email_allow_optout]" VALUE="1" <?php checked(1, $crew_manager_options['crew_email_allow_optout'], true); ?>>Allow
		 <input type="radio" name="crew_manager_settings[crew_email_allow_optout]" VALUE="2" <?php checked(2, $crew_manager_options['crew_email_allow_optout'], true); ?>>Deny<br />
				<span class="description">Select to Allow or Deny Crew setting for email optout using radio buttons.</span>
			</td>
			<td>
			Using <em>Allow</em> or <em>Deny</em> options, the Optout setting for Crew is displayed in their user profile (always available for the Skipper).  Optout turns off Crew emails for new posts and comments only.  Crew always get reminders for events they are crewing.
			</td>
		</tr>

		<tr>
			<td><label for="crew_manager_settings[lead_time]">
                <?= __('<b>Crew Reminder <br>Email Lead Time</b>', 'textdomain') ?>
                </label>
			</td>
			<td>
				<b>Crew reminder email sent </b> <input type="text" name="crew_manager_settings[lead_time]" id="crew_manager_settings[lead_time]" size="2" value="<?= $crew_manager_options['lead_time'] ?>"> <b> hours before an event.</b> <br />
				<span class="description">Type number of hours in advance of event that a crew reminder email is sent.</span>
			</td>
			<td>
			Sets the number of hours prior to an event that a reminder email is sent to crew scheduled for that event.  
			</td>
		</tr>
		<tr>
			<td><label for="crew_manager_settings['stop_elp_notifications']">
                <?= __('<b>Suppress Skipper<br>Sent message Email notifications</b>', 'textdomain') ?>
                </label>
			</td>
			<td>
		 <b>Skipper Notification Email Preference:&nbsp;&nbsp;</b>
 <input type="radio" name="crew_manager_settings[stop_elp_notifications]" VALUE="1" <?php checked(1, $crew_manager_options['stop_elp_notifications'], true); ?>>On
		 <input type="radio" name="crew_manager_settings[stop_elp_notifications]" VALUE="2" <?php checked(2, $crew_manager_options['stop_elp_notifications'], true); ?>>Off<br />
				<span class="description">Select to turn On / Off notification messages when emails are sent.</span>
			</td>
			<td>
			Using the <em>On</em> or <em>Off</em> options, the Email notifications to the Skipper (and selected alternate) may be enabled.  This is good for debug, but once all is working, the notification messages may be turned off.
			</td>
		</tr>
		<tr>
			<td><label for="crew_manager_settings[skipper]">
                <?= __('<b>Designate the Skipper ...<br>The Captain of the Ship!</b>', 'textdomain') ?>
                </label>
			<td>
				<? echo get_crew_dropdown($crew_manager_options['skipper'],'skipper'); ?><br />
				<span class="description">Select the Skipper from the dropdown list to grant Crew Manager Skipper Access</span>
			</td>
			<td>
			Provides Crew Manager Skipper Access via menus to enable crew management, add, edit and delete crew members, create & edit events, post results, and upload media.
			</td>
		</tr>
		<tr>
			<td><label for="crew_manager_settings[skipper_admin]">
                <?= __('<b>Designate Skipper Access for<br>an Additional Crew Member</b>', 'textdomain') ?>
                </label>
			<td>
				<? echo get_crew_dropdown($crew_manager_options['skipper_admin'],'skipper_admin'); ?><br />
				<span class="description">Select one other to designate with Skipper Access rights.</span>
			</td>
			<td>
			Provides Skipper Access for an additional crew member who may assist the Skipper with crew managment.
			</td>
		</tr>

		<tr>
			<td><label for="crew_manager_settings[crew_hide]">
                <?= __('<b>Suppress Display of Crew<br><em>Not Available</em> for Events</b>', 'textdomain') ?>
                </label>
			</td>
			<td>
		 <b>Hide Crew <em>Not Available</em> on Calendar Events:&nbsp;&nbsp;</b>
 <input type="radio" name="crew_manager_settings[crew_hide]" VALUE="1" <?php checked(1, $crew_manager_options['crew_hide'], true); ?>>Hide
		 <input type="radio" name="crew_manager_settings[crew_hide]" VALUE="2" <?php checked(2, $crew_manager_options['crew_hide'], true); ?>>Show<br />
		<b>Hide Crew <em>Not Available</em> on Assignments List:&nbsp;</b>
		 <input type="radio" name="crew_manager_settings[availability_hide]" VALUE="1" <?php checked(1, $crew_manager_options['availability_hide'], true); ?>>Hide
		 <input type="radio" name="crew_manager_settings[availability_hide]" VALUE="2" <?php checked(2, $crew_manager_options['availability_hide'], true); ?>>Show<br />
				<span class="description">Select to hide crew "Not Available" using radio buttons.</span>
			</td>
			<td>
			Using the <em>Hide</em> or <em>Show</em> options, "Not Available" crew may be hidden from the event list (Calendar Entries) and from <em>Crew Assignments</em> on the menu.  It is always possible to view "Not Available" status for all crew via Skipper menu items and for Crew who are logged in using <em>Crew Availability</em> on the menu. 
			</td>
			</tr>

		<tr>
			<td><label for="crew_manager_settings[weight_limit]">
                <?= __('<b>Customize Crew Weight<br>Reports for Events</b>', 'textdomain') ?>
                </label>
			</td>
			<td>
		 <b><em>Helmsman</em>:&nbsp;&nbsp;</b>
 <input type="radio" name="crew_manager_settings[include_helm]" VALUE="1" <?php checked(1, $crew_manager_options['include_helm'], true); ?>>Excluded
		 <input type="radio" name="crew_manager_settings[include_helm]" VALUE="2" <?php checked(2, $crew_manager_options['include_helm'], true); ?>>Included <b>with Crew Weight</b><br />
		<b>One Design Class Allowed Crew Weight:&nbsp;</b>

<input type="text" name="crew_manager_settings[weight_limit]" id="crew_manager_settings[weight_limit]" style="text-align: right" size="2" value="<?= $crew_manager_options['weight_limit'] ?>"> <b> pounds.</b> <br />
				<span class="description">Type weight in pounds for Total Crew Weight Limit. &nbsp; Leave as 0 for no limit.</span>
			</td>
			<td>
			Using <em>Exclude</em> or <em>Include</em> options, Helmsman weight may be excluded from Total Crew Weight Report calculations.  One Design Class weight limits may entered to compare with total calculated crew weight.  Enter 0 if no limit. 
			</td>
			</tr>


		<tr>
			<td><label for="crew_manager_settings[elp_cron_trigger]">
                <?= __('<b>CRON trigger source to<br>send scheduled reminders</b>', 'textdomain') ?>
                </label>
			</td>
			<td>
		 <b>CRON trigger source information is copied from this page ==>&nbsp;&nbsp;</b>
<br />
				<span class="description">CRON settings must be saved in cPanel</span>
			</td>
			<td>
	<? 
$pluginpath = plugin_dir_path( __DIR__ );
$path = "php -f ".$pluginpath. "cron/get-eventcrew-crontask.php >/dev/null 2>&1"; ?>
			The <em>Crew Manager</em> plugin is triggered once per hour to check for scheduled events.  Copy the link inthe box below to setup an hourly CRON at minute 59 every hour in cPanel for <em>Crew Manager</em>: <br><input type="text" id="path" name="path" size="125" value="<? echo $path; ?>"><br>
		</td>
		</tr>
		<tr>
			<td></td>
			<td>
        <?php do_settings_fields('crew_manager_group', 'default') ?>
        <?php do_settings_sections('crew_manager_group') ?>
        <?php submit_button( 'Save All Changes') ?>
			</td>
    </form>
		</tr>
	</table>
<?
}

/**
* This function displays the Edit Position screen as
* a submenu that is off the crew manager admin page 
**/

function crew_manager_edit_positions_page(){
echo "<h1> Rename, Delete or Add Crew Position Titles</h1>";
$text_boxes = load_position_text_boxes_admin();
?>

<form action="" method="post">

    <table width="100%"  frame="box" border="0" cellspacing="0" cellpadding="0" >
    <tr><td width="30px">&nbsp;</td> <td width="220px"><? echo $text_boxes; ?></td>
    <td width="60%">
<p><h3>These Crew Positions are displayed in a dropdown where the Skipper may designate crew member positions for an event.</h3></p>
<p><h3>The positions of <em>Not Assigned</em>, <em>Standby Crew</em> and <em>Stay Ashore</em> are available but may not be changed.</h3></p>
	<ul>
		<li>-- <em>Not Assigned</em> is default for crew not yet assigned to a position by the Skipper.  The row is color coded with a white dot / white background.</li>
		<li>-- <em>Standby Crew</em> is assigned by the Skipper for crew who may be scheduled for the event, but not yet confirmed. The crew member must verify with the Skipper the day of the event if still coded as <em>Standby Crew</em>.  The row is color coded with a yellow dot / yellow background.</li>
		<li>-- <em>Stay Ashore</em> is assigned when there are too many crew with availability set to <em>Yes</em>.  This designates a crew member who is not on the boat for the event. The row is color coded with a red dot / pink background.</li>
		<li>-- Any crew member who has indicated <em>Yes</em> for availability and is assigned a position by the Skipper designates a crew member confirmed for the event. The row is color coded with a green dot / green background, unless assigned the position of <em>Standby Crew</em> or <em>Stay Ashore</em>.</li>
		<li>-- Any crew member who has indicated <em>Maybe</em> for availability and is assigned a position by the Skipper designates a crew member as possible for the event. The row is color coded with a yellow dot / yellow background.  If the individual changes availability to <em>Yes</em> the 
position is confirmed and the row is color coded with a green dot / green background.</li>

	</ul>
<p>&nbsp;</p>
<p><h4>To modify a position, edit the text in the box.</h4></p>
<p><h4>To delete a position, check the box next to it.  Note - Any crew member assigned that position will need to be reassigned.</h4></p>
<p><h4>To add a positon, type text in the box at the bottom.</h4></p>
<p><h4>Click <em> Submit Position Updates</em> to save changes.</h4></p>
<br><input type="submit" name="submit_positions" value="Submit Position Updates" style="font-size:10pt;color:white;
background-color:#1B8CB8;border:1px solid #054A83;padding:5px;<font color='"White"'/>
</td><td width="5%"></td></tr>

</form>
<?php
// add routine to process position updates here
if(isset($_POST['submit_positions'])){
// echo "process position updates clicked<br><br>"; //debug
if($_POST['newposition']!=""){
$newposition=$_POST['newposition'];
// echo "<br>New Position Process for ".$newposition."<br>"; //debug
global $wpdb;  // setup query to insert new position
    $table_crewmgr_position  = $wpdb->prefix."crewmgr_position";
    $wpdb->insert($table_crewmgr_position, array(
        'position_id' => '',
        'position' => $newposition,
    ));
}// end processing new position
$position = $_POST['position'];  //sets up array with all dropdown values
$delete = $_POST['delete'];  //sets up array with all dropdown values

global $wpdb;
    $table_crewmgr_position  = $wpdb->prefix."crewmgr_position";
$query = $wpdb->get_results("SELECT * FROM $table_crewmgr_position 
					ORDER BY position", ARRAY_A);
foreach($query as $myrow)
	{
	  if ($myrow["position"]!= "Not Assigned" && $myrow["position"]!=  "Stay Ashore" && $myrow["position"]!= "Standby Crew" && $myrow["position"] != $newposition) { 
// exclude these from editing
		if ($myrow["position"]!=$position[$myrow["position_id"]]) {
	$new_position = $position[$myrow["position_id"]];
	$old_position = $myrow["position"];
	$position_id = $myrow["position_id"];
//  echo $old_position. " is now " . $new_position." position_id: ".$position_id."<br>";  // debug

global $wpdb;
    $table_crewmgr_position  = $wpdb->prefix."crewmgr_position";
        $wpdb->query("UPDATE $table_crewmgr_position SET position='$new_position' WHERE position_id = '$position_id'");
		   } // endif comparing changes 
//   		 echo $myrow["position"]. " is unchanged<br>"; // debug
// delete routine here
if ($delete[$myrow["position_id"]]==1){
	$position_id = $myrow["position_id"];
// echo "<br><br>final delete: ".$myrow[position]. "  position_id: ". $position_id; // debug

global $wpdb;
 $wpdb->query("DELETE  FROM $table_crewmgr_position WHERE position_id = '$position_id'");
	  } // endif delete check editing
	  } // endif exclude editing
	} // end foreach $query
     echo "<h1><font color=\"red\"><center>Refreshing Display</center></font></h1>";

echo "<meta http-equiv='refresh' content='0'>"; 
} // end processing submit
?>
			</td>
		</tr>
	</table>
<?
} // end function crew_manager_edit_positions_page 

/**
* This function displays the Email list management screen as
* a submenu that is off the crew manager admin page 
**/

function crew_manager_email_list_page(){
echo "<h1> Manage Email Lists & Other User Settings</h1>";
$check_boxes = load_crew_check_boxes_admin();

global $crew_manager_options;
?>
	<table class="form-table">
<form action="" method="post">
    <tr>
<h3>Update Email Groups for Sending Posts to selected Crew Members & Display on Crew Dropdowns</h3>
	<ul>
	<h4>Check the boxes by each name to include selected crew members in the labeled groups, then click <em>Update Email Groups</em> to save the changes.</h4>
	<li><b><em>Retired</em></b> group is removed from the crew roster display, and the crew dropdowns when assigning positions. The users still have accounts and may log in.<br><b><em>Core Crew</em></b> group receives special email messages sent by the Skipper<br><b><em>All Posts</em></b> group receive new posts published and related post comments submitted</li>
	<li>Update email distribution as crew members are added, or crew members are no longer active.  For Crew who join for only one or two events add as users without checking <em>All Posts</em> so they will receive event reminders and results for events crewed but don't need to receive posts that are published.  Check <em>Retired</em> to remove them from the dropdowns when no longer needed.</li>
	</ul>
<td style="border-top: 6px solid #2874A6;" width="2%">&nbsp;</td> <td style="border-top: 6px solid #2874A6;"><? echo $check_boxes; ?></td>
    </tr>

		<tr>
			<td style="border-bottom: 6px solid #2874A6;"></td>
			<td style="border-bottom: 6px solid #2874A6;">
<input type="submit" name="submit_email_group" value="Update Email Groups" style="font-size:10pt;color:white;
background-color:#1B8CB8;border:1px solid #054A83;padding:5px;<font color='"White"'/>
			</td>
			</tr>

<?php
// add routine to process email group here
if(isset($_POST['submit_email_group'])){
if($_POST['retired']!=""){
$retired=$_POST['retired'];}
if($_POST['corecrew']!=""){
$corecrew=$_POST['corecrew'];}
if($_POST['allposts']!=""){
$allposts=$_POST['allposts'];}

update_crew_email_list($retired, $corecrew, $allposts); //this is new method saved as user meta
?>
<h1>Email Groups Successfully Updated in Database</h1>
<meta http-equiv='refresh' content='0'>
</form>
<?
} // endif POST[submit_email_group]
?>
			</td>
		</tr>
	</table>
<?
} // end function crew_manager_email_list_page 


/**
* This function displays the Skipper Email screen as
* a submenu that is off the crew manager admin page 
**/

function crew_manager_skipper_email_page(){
echo "<h1> Skipper Send Email to Crew Groups and Event Participants</h1>";
global $crew_manager_options;
$user_info = get_userdata( $crew_manager_options['skipper'] );
$from_email = $user_info->user_email;
$skipper_name = $user_info->first_name." ".$user_info->last_name;
$headers[] = 'Content-Type: text/html; charset=UTF-8';
$headers[] = "From: ".$skipper_name." <".$from_email.">";
$to_group = get_to_group_dropdown();
$boat = get_bloginfo( 'name' );
?>

<form action="" method="post">

    <h3>To: </h3>&nbsp;&nbsp;<? echo $to_group; ?>
	<h3>Send Email to Each <em>Individual</em> or <em>Group</em> (Group allows reply to all)</h3>
<input type="radio" name="group_or_individual" VALUE="individual">Individual
<input type="radio" name="group_or_individual" VALUE="group" CHECKED>Group

<p><h3>Subject:</h3></p>
<input type='text' name='subject' id='subject' size='85' value='' placeholder='If left blank defaults to: A Message from the <? echo $boat; ?> Skipper'>
<h3>Message Content:</h3>
    <table width="100%"  frame="box" border="0" cellspacing="0" cellpadding="0" >
<tr>
	<td width="60%>
		<?
			$settings = array(
			'textarea_name' => 'message_content',
			'textarea_rows' => 20,
			'wpautop' => false  );
		wp_editor( 'Type over this text', 'email_content', $settings );
		?>
	</td>
	<td width="2%"></td>
	<td><ul>
		<li><strong>Select email recipients</strong> in the dropdown below <em><strong>To:</strong></em></li>
		<li><strong>Select <em>Group</em> or <em>Individuals</em></strong> on method email recipients should be addressed.</li>
		<li><strong>Type message subject</strong> in the text box provided below <strong><em>Subject:</em></strong></li>
		<li><strong>Click the <em>Visual</em> tab</strong> at the top right of the <strong><em>Message Content</em></strong> area</li>
		<li><strong>Type message in the <em>Message Content</em> area</strong> provided and format using the toolbar below <strong><em>Message Content:</em></strong></li>
		<li><strong>Click <em>Send Email</em></strong> to send the message.</li>
	</ul></td>
</tr>
<tr>
	<td width="10%"><br><input type="submit" name="send_email" value="Send Email" style="font-size:10pt;color:white;background-color:#1B8CB8;border:1px solid #054A83;padding:5px;<font color='"White"'/>
	</td>
</tr>

</form>
<?php
// add routine to process position updates here
if(isset($_POST['send_email'])&& $_POST['to_group']>>0){
// echo "process sending email<br><br>"; //debug
$to_group=$_POST['to_group'];
if($to_group >>2){ 
// group is defined by the crew assigned to an event
 $email_array = get_email_for_post($to_group);
} else {
// group is defined by skipper in admin panel
if($to_group==1) $group = 'corecrew';
if($to_group==2) $group = 'allposts';
 $email_array = get_email_for_group($group);
} // end if($to_group !>>2)
$group_or_individual=$_POST['group_or_individual'];
$subject=$_POST['subject'];
if($subject=="") $subject= do_shortcode("A Message from the [boat] Skipper");
$email_content=stripslashes(do_shortcode($_POST['message_content'])); // strips slashes that broke formatting and images, and executes crew shortcode
$email_array_column = array_column($email_array, 'formatted_email');
$group_recipients = array_column($email_array, 'group_recipients');
$recipients = array_column($email_array, 'recipients');
$number_recipients = array_column($email_array, 'number_recipients');
/************** // debug stuff in this section
 echo "group_recipients: " . $group_recipients[0] . "<br>"; //debug
 echo "recipients: " . $recipients[0]  . "<br>"; //debug
 echo "number_recipients: " . $number_recipients[0] . "<br>"; //debug
 echo "<br>to group: ".$to_group."<br>"; //debug
 echo "<br>group or individual: ".$group_or_individual."<br>"; //debug
 echo "<br>subject: ".$subject."<br>"; //debug
 echo "<br>email content: ".$email_content."<br>"; //debug
***********/
if($group_or_individual=='group'){
	if($crew_manager_options['stop_crew_email']==1) wp_mail( $group_recipients[0], $subject, $email_content, $headers ); // sends to group visible to all html formatted email if enabled in admin panel
$send_crew_message = "Group Email Sent to " . $number_recipients[0] . " Crew Members<br>"; 
} ELSE // end $group_or_individual=='group'
	{ // $group_or_individual=='individual'
		$email_array_column = array_column($email_array, 'formatted_email');
		$send_crew_message = "Email Sent to " . $number_recipients[0] . " Crew Members Individually<br>"; 
		foreach($email_array_column as $email_record){ // this array iteration sends the message to each person
			if($crew_manager_options['stop_crew_email']==1) wp_mail( $email_record, $subject, $email_content, $headers ); // sends html formatted email to each individual if enabled in admin panel
		}// foreach($email_array_column as $email_record)

	} // end ELSE $group_or_individual=='individual'

			if($crew_manager_options['stop_crew_email']==2)$send_crew_message = "No Crew Emails Sent - Crew Emails are Turned Off in the Crew Manager Admin Setup<br>"; 
$content = "A Skipper generated email was sent successfully to " . $number_recipients[0] . " email addresses. Please find the details below<br><br>";
send_notification_email($subject, $content, $recipients[0], $post_id=0);

     echo "<h1><font color=\"red\">" . $send_crew_message . "<br>Refreshing Display</font></h1>";

 echo "<meta http-equiv='refresh' content='0'>"; 
} // end processing submit
?>
			</td>
		</tr>
	</table>
<?
} // end function crew_manager_skipper_email_page 
?>